<?php

/**
 * Generated by the WordPress Option Page generator
 * at http://jeremyhixon.com/wp-tools/option-page/
 */

class BucketBlazeOptions {
	private $bucketblaze_options_options;

	public function __construct() {
		add_action( 'admin_menu', array( $this, 'bucketblaze_options_add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'bucketblaze_options_page_init' ) );
	}

	public function bucketblaze_options_add_plugin_page() {
		add_options_page(
			'BucketBlaze Options', // page_title
			'BucketBlaze Options', // menu_title
			'manage_options', // capability
			'bucketblaze-options', // menu_slug
			array( $this, 'bucketblaze_options_create_admin_page' ) // function
		);
	}

	public function bucketblaze_options_create_admin_page() {
		$this->bucketblaze_options_options = get_option( 'bucketblaze_options_option_name' ); ?>

        <div class="wrap">
            <h2>BucketBlaze Options</h2>
            <p></p>
			<?php settings_errors(); ?>

            <form method="post" action="options.php">
				<?php
				settings_fields( 'bucketblaze_options_option_group' );
				do_settings_sections( 'bucketblaze-options-admin' );
				submit_button();
				?>
            </form>
        </div>

        <div class="wrap">

            <h2>Configuration Details</h2>
            <br>



			<?php

			if(isset($_GET['settings-updated']) && $_GET['settings-updated'] == 'true'){
				echo "<h2>Settings updated</h2>";

				//isset($_GET['update_config']) && $_GET['update_config']=='true' &&
				if( $this->is_curl_installed()){
					echo "<div> curl installed, pulling configuration</div>";

					$bucketblaze_options_options = get_option( 'bucketblaze_options_option_name' );
					$api_key_0 = $bucketblaze_options_options['api_key_0'];
					if(!empty($api_key_0)){
						echo "<div> API key found".substr($api_key_0,0, 3)."...</div>";
						$response = $this->pullConfigurationFromServer($api_key_0);
						//var_dump($response);
						$response = json_decode($response, true);
						//var_dump($response);
						if($response != null){
							if($response['status'] == 'success'){
								update_option( 'bucketblaze_downloads_config', $response['config'], $autoload = false );
								echo "<div>Configuration stored successfully! {$response['config'][0]['customerId']}</div>";
							}else{
								echo "<div>{$response['message']}</div>";
							}
						}else{
							echo "<h4>Error connecting to BucketBlaze server</h4>";
							return;
						}


					}else{
						echo "<div>API KEY missing!</div>";
					}

				}else{
					echo "<div>error: curl not installed</div>";
				}

			}


			$downloadConfig = get_option('bucketblaze_downloads_config', false);

			if($downloadConfig){
				?>

                <table class="zui-table">
                    <thead>
                    <tr>
                        <th>Customer Id</th>
                        <th>Bucket</th>
                        <th>Signing key</th>
                    </tr>
                    </thead>
                    <tbody>

					<?php

					foreach($downloadConfig as $key => $value){
						$signingKeyTruncated = substr($value['signing_key'],0, 4);
						echo "<tr>
                        <td>{$value['customerId']}</td>
                        <td>$key</td>    
                        <td>{$signingKeyTruncated}...</td>
</tr>";
					}

					?>
                    </tbody>
                </table>

                <style>
                    .zui-table {
                        border: solid 1px #DDEEEE;
                        border-collapse: collapse;
                        border-spacing: 0;
                        font: normal 13px Arial, sans-serif;
                    }
                    .zui-table thead th {
                        background-color: #DDEFEF;
                        border: solid 1px #DDEEEE;
                        color: #336B6B;
                        padding: 10px;
                        text-align: left;
                        text-shadow: 1px 1px 1px #fff;
                    }
                    .zui-table tbody td {
                        border: solid 1px #DDEEEE;
                        color: #333;
                        padding: 10px;
                        text-shadow: 1px 1px 1px #fff;
                    }
                </style>

				<?php
			}else{
				echo "<h4>Missing configuration, add api key and save</h4>";
			}//endif configuration table




			echo "</table>";

			?>


        </div>

	<?php }


	private function pullConfigurationFromServer($apiKey){

		$domain = $_SERVER["SERVER_NAME"];
		$post = [
			'api_key' => $apiKey,
		];

		$ch = curl_init('https://bucketblaze.com/dashboard/configuration-pull');
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
		curl_setopt($ch, CURLOPT_REFERER, $domain);
		$response = curl_exec($ch);
		curl_close($ch);
		return $response;
	}

	public function bucketblaze_options_page_init() {
		register_setting(
			'bucketblaze_options_option_group', // option_group
			'bucketblaze_options_option_name', // option_name
			array( $this, 'bucketblaze_options_sanitize' ) // sanitize_callback
		);

		add_settings_section(
			'bucketblaze_options_setting_section', // id
			'Settings', // title
			array( $this, 'bucketblaze_options_section_info' ), // callback
			'bucketblaze-options-admin' // page
		);

		add_settings_field(
			'api_key_0', // id
			'API key', // title
			array( $this, 'api_key_0_callback' ), // callback
			'bucketblaze-options-admin', // page
			'bucketblaze_options_setting_section' // section
		);
	}

	public function bucketblaze_options_sanitize($input) {
		$sanitary_values = array();
		if ( isset( $input['api_key_0'] ) ) {
			$sanitary_values['api_key_0'] = sanitize_text_field( $input['api_key_0'] );
		}

		return $sanitary_values;
	}

	public function bucketblaze_options_section_info() {

	}

	public function api_key_0_callback() {
		printf(
			'<input class="regular-text" type="password" name="bucketblaze_options_option_name[api_key_0]" id="api_key_0" value="%s">',
			isset( $this->bucketblaze_options_options['api_key_0'] ) ? esc_attr( $this->bucketblaze_options_options['api_key_0']) : ''
		);
	}

	private function is_curl_installed() {
		if  (in_array  ('curl', get_loaded_extensions())) {
			return true;
		}
		else {
			return false;
		}
	}


}
if ( is_admin() )
	$bucketblaze_options = new BucketBlazeOptions();

/*
 * Retrieve this value with:
 * $bucketblaze_options_options = get_option( 'bucketblaze_options_option_name' ); // Array of All Options
 * $api_key_0 = $bucketblaze_options_options['api_key_0']; // API key
 */
